#pragma once


// I/O Definitionen
#define MAX487_TXRX_OUT		sbi (DDRA,0)	// PA0 Ausgang, MAX487 /RE_DE
#define MAX487_senden		sbi (PORTA,0)	// MAX487 /RE_DE - umschalten auf senden
#define MAX487_empfangen	cbi (PORTA,0)	// MAX487 /RE_DE - umschalten auf empfangen

#define Pin_TxD0_OUT	sbi (DDRA,1)	// TxD0 Ausgang
#define Pin_TxD0_ON		sbi (PORTA,1)	// TxD0 einschalten
#define Pin_TxD0_OFF	cbi (PORTA,1)	// TxD0 ausschalten
#define Pin_RxD0_IN		cbi (DDRA,2)	// RxD0 Eingang
#define Pin_RxD0_PULL	sbi (PUEA,2)	// RxD0 Pullup aktiv

#define K6_1_OUT	sbi (DDRA,3)	// PA3 Ausgang
#define K6_2_OUT	sbi (DDRA,4)	// PA4 Ausgang
#define K6_3_OUT	sbi (DDRA,5)	// PA5 Ausgang
#define K6_4_OUT	sbi (DDRA,6)	// PA6 Ausgang
#define K7_5_OUT	sbi (DDRA,7)	// PA7 Ausgang
#define K7_6_OUT	sbi (DDRB,2)	// PB2 Ausgang
#define K7_7_OUT	sbi (DDRB,1)	// PB1 Ausgang
#define K7_8_OUT	sbi (DDRB,0)	// PB0 Ausgang

#define K6_1_ON		sbi (PORTA,3)	// PA3 einschalten
#define K6_2_ON		sbi (PORTA,4)	// PA4 einschalten
#define K6_3_ON		sbi (PORTA,5)	// PA5 einschalten
#define K6_4_ON		sbi (PORTA,6)	// PA6 einschalten
#define K7_5_ON		sbi (PORTA,7)	// PA7 einschalten
#define K7_6_ON		sbi (PORTB,2)	// PB2 einschalten
#define K7_7_ON		sbi (PORTB,1)	// PB1 einschalten
#define K7_8_ON		sbi (PORTB,0)	// PB0 einschalten

#define K6_1_OFF	cbi (PORTA,3)	// PA3 ausschalten
#define K6_2_OFF	cbi (PORTA,4)	// PA4 ausschalten
#define K6_3_OFF	cbi (PORTA,5)	// PA5 ausschalten
#define K6_4_OFF	cbi (PORTA,6)	// PA6 ausschalten
#define K7_5_OFF	cbi (PORTA,7)	// PA7 ausschalten
#define K7_6_OFF	cbi (PORTB,2)	// PB2 ausschalten 
#define K7_7_OFF	cbi (PORTB,1)	// PB1 ausschalten
#define K7_8_OFF	cbi (PORTB,0)	// PB0 ausschalten
// -----------------------------------------------------------------

// Servo Definitionen, On/Off invertiert wegen Mosfet
#define Servo1_OUT	sbi (DDRA,3)	// PA3 Ausgang
#define Servo2_OUT	sbi (DDRA,4)	// PA4 Ausgang
#define Servo3_OUT	sbi (DDRA,5)	// PA5 Ausgang
#define Servo4_OUT	sbi (DDRA,6)	// PA6 Ausgang
#define Servo5_OUT	sbi (DDRA,7)	// PA7 Ausgang
#define Servo6_OUT	sbi (DDRB,2)	// PB2 Ausgang
#define Servo7_OUT	sbi (DDRB,1)	// PB1 Ausgang
#define Servo8_OUT	sbi (DDRB,0)	// PB0 Ausgang
// Servo Definitionen, On/Off invertiert wegen Mosfet
#define Servo1_OFF	sbi (PORTA,3)	// PA3 einschalten, invertiert
#define Servo2_OFF	sbi (PORTA,4)	// PA4 einschalten, invertiert
#define Servo3_OFF	sbi (PORTA,5)	// PA5 einschalten, invertiert
#define Servo4_OFF	sbi (PORTA,6)	// PA6 einschalten, invertiert
#define Servo5_OFF	sbi (PORTA,7)	// PA7 einschalten, invertiert
#define Servo6_OFF	sbi (PORTB,2)	// PB2 einschalten, invertiert
#define Servo7_OFF	sbi (PORTB,1)	// PB1 einschalten, invertiert
#define Servo8_OFF	sbi (PORTB,0)	// PB0 einschalten, invertiert
// Servo Definitionen, On/Off invertiert wegen Mosfet
#define Servo1_ON	cbi (PORTA,3)	// PA3 ausschalten, invertiert
#define Servo2_ON	cbi (PORTA,4)	// PA4 ausschalten, invertiert
#define Servo3_ON	cbi (PORTA,5)	// PA5 ausschalten, invertiert
#define Servo4_ON	cbi (PORTA,6)	// PA6 ausschalten, invertiert
#define Servo5_ON	cbi (PORTA,7)	// PA7 ausschalten, invertiert
#define Servo6_ON	cbi (PORTB,2)	// PB2 ausschalten, invertiert
#define Servo7_ON	cbi (PORTB,1)	// PB1 ausschalten, invertiert
#define Servo8_ON	cbi (PORTB,0)	// PB0 ausschalten, invertiert
// -----------------------------------------------------------------

// LED Testpin Definitionen, On/Off
#define Led1_OUT	sbi (DDRA,3)	// PA3 Ausgang
#define Led2_OUT	sbi (DDRA,4)	// PA4 Ausgang
#define Led3_OUT	sbi (DDRA,5)	// PA5 Ausgang
#define Led4_OUT	sbi (DDRA,6)	// PA6 Ausgang
#define Led5_OUT	sbi (DDRA,7)	// PA7 Ausgang
#define Led6_OUT	sbi (DDRB,2)	// PB2 Ausgang
#define Led7_OUT	sbi (DDRB,1)	// PB1 Ausgang
#define Led8_OUT	sbi (DDRB,0)	// PB0 Ausgang
// 
#define Led1_ON		sbi (PORTA,3)	// PA3 einschalten
#define Led2_ON		sbi (PORTA,4)	// PA4 einschalten
#define Led3_ON		sbi (PORTA,5)	// PA5 einschalten
#define Led4_ON		sbi (PORTA,6)	// PA6 einschalten
#define Led5_ON		sbi (PORTA,7)	// PA7 einschalten
#define Led6_ON		sbi (PORTB,2)	// PB2 einschalten
#define Led7_ON		sbi (PORTB,1)	// PB1 einschalten
#define Led8_ON		sbi (PORTB,0)	// PB0 einschalten
// 
#define Led1_OFF	cbi (PORTA,3)	// PA3 ausschalten
#define Led2_OFF	cbi (PORTA,4)	// PA4 ausschalten
#define Led3_OFF	cbi (PORTA,5)	// PA5 ausschalten
#define Led4_OFF	cbi (PORTA,6)	// PA6 ausschalten
#define Led5_OFF	cbi (PORTA,7)	// PA7 ausschalten
#define Led6_OFF	cbi (PORTB,2)	// PB2 ausschalten
#define Led7_OFF	cbi (PORTB,1)	// PB1 ausschalten
#define Led8_OFF	cbi (PORTB,0)	// PB0 ausschalten
// -----------------------------------------------------------------

#define K4_1_IN		cbi (DDRA,3)	// PA3 Eingang
#define K4_2_IN		cbi (DDRA,4)	// PA4 Eingang
#define K4_3_IN		cbi (DDRA,5)	// PA5 Eingang
#define K4_4_IN		cbi (DDRA,6)	// PA6 Eingang
#define K5_5_IN		cbi (DDRA,7)	// PB7 Eingang
#define K5_6_IN		cbi (DDRB,2)	// PB2 Eingang
#define K5_7_IN		cbi (DDRB,1)	// PB1 Eingang
#define K5_8_IN		cbi (DDRB,0)	// PB0 Eingang

#define K4_1_PULL	sbi (PUEA,3)	// PA3 Pullup aktiv
#define K4_2_PULL	sbi (PUEA,4)	// PA4 Pullup aktiv
#define K4_3_PULL	sbi (PUEA,5)	// PA5 Pullup aktiv
#define K4_4_PULL	sbi (PUEA,6)	// PA6 Pullup aktiv
#define K5_5_PULL	sbi (PUEA,7)	// PB7 Pullup aktiv
#define K5_6_PULL	sbi (PUEB,2)	// PB2 Pullup aktiv
#define K5_7_PULL	sbi (PUEB,1)	// PB1 Pullup aktiv
#define K5_8_PULL	sbi (PUEB,0)	// PB0 Pullup aktiv